-- Seles (The Arctic Fox) by Sls64LGamingBro
-- Lua made by Sls64LGamingBro (Me)


freeslot("SKINCOLOR_SNOWYWHITE", "S_PLAY_BONK", "sfx_slsvic", "sfx_slsvi2", "sfx_slsvi3", "sfx_slsvi4")
skincolors[SKINCOLOR_SNOWYWHITE] = {
    name = "Snowy_White",
    ramp = {0,2,4,5,7,9,10,11,12,13,14,15,16,17,18,19},
    invcolor = SKINCOLOR_WHITE,
    invshade = 9,
    chatcolor = V_WHITEMAP,
    accessible = true
}

-- Yeah. Bro has a voice now, lol.


COM_AddCommand("selesvoice", function(p, arg)
    if arg == nil
		CONS_Printf(p, "A toggle for specifically seles's Voice. You can toggle the command either on or off.")
		S_StartSound(nil, sfx_s3kad, p)
    elseif arg == "on" or arg == "yes" or arg == "1"
	    p.victoryvoice = true
	    CONS_Printf(p, "Seles's Voice is on")
	elseif arg == "off" or arg == "no" or arg == "0"
        p.victoryvoice = false
	    CONS_Printf(p, "seles's Voice is off")
	else CONS_Printf(p, "Invaild")
		S_StartSound(nil, sfx_notadd, p)
	end	
end)


function A_RandomSound(mobj)
	local selectionvoice = P_RandomRange(1, 4)
	if not S_SoundPlaying(mobj, sfx_slsvic)
	and not S_SoundPlaying(mobj, sfx_slsvi2)
	and not S_SoundPlaying(mobj, sfx_slsvi3)
	and not S_SoundPlaying(mobj, sfx_slsvi4)
		if (selectionvoice == 1)
			S_StartSound(mobj, sfx_slsvic)
		elseif (selectionvoice == 2)
			S_StartSound(mobj, sfx_slsvi2)
		elseif (selectionvoice == 3)
			S_StartSound(mobj, sfx_slsvi3)
		elseif (selectionvoice == 4)
			S_StartSound(mobj, sfx_slsvi4)			
		end
	end
end

	
addHook("PlayerThink", function(p)
	if p.mo.boostflight == nil
		p.mo.boostflight = 3
	end	
end)


addHook("ThinkFrame", function()
    for p in players.iterate do
        if p.botpose == nil then
			p.botpose = 0
        end
    end
end)


//Main


addHook("AbilitySpecial", function(p)
	local mo = p.mo
	if p.mo.skin == "seles"
	and p.powers[pw_tailsfly] > 0
	and p.mo.boostflight > 0
		S_StartSound(p.mo, sfx_s3k82)
		P_SetObjectMomZ(p.mo, 10*FRACUNIT)
		local circle = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)
		circle.fuse = 8
		circle.colorized = true
		circle.frame = TR_TRANS10
		circle.color = p.mo.color
		circle.state = S_FACESTABBERSPEAR
		circle.angle = p.drawangle+ANGLE_90
		p.mo.boostflight = $-1
	end
	if p.mo.boostflight == 2
	    P_Thrust(p.mo, p.mo.angle, 5*FRACUNIT)
	end
	if p.powers[pw_super]
	and p.mo.boostflight == 5
	    P_Thrust(p.mo, p.mo.angle, 7*FRACUNIT)
	end
end)


addHook("PlayerThink", function(p)
	local mo = p.mo
	if (mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(mo))
	and not (p.cmd.buttons & BT_JUMP) then
		if p.powers[pw_super] then
			mo.boostflight = 6
		else
			mo.boostflight = 3
		end
	end
end)


addHook("PlayerThink", function(p)
	if (p.mo.skin == "seles")
	    and (p.mo.state == S_PLAY_JUMP)
		and (p.cmd.buttons & BT_SPIN)
		and not (p.mo.state == S_PLAY_PAIN)
		and not (p.mo.state == S_PLAY_DEAD)
		and not (p.mo.state == S_PLAY_DRWN)
		and not (p.powers[pw_shield])
		and not (p.powers[pw_super])
		and not (CBW_Battle)
		p.charging = true
		p.mo.state = S_PLAY_SPINDASH
		S_StartSound(p.mo, sfx_spndsh)
	end
    if (p.mo.state == S_PLAY_JUMP)
		and (p.cmd.buttons & BT_SPIN)
	    and (CBW_Battle)
		and not (p.mo.state == S_PLAY_PAIN)
		and not (p.mo.state == S_PLAY_DEAD)
		and not (p.mo.state == S_PLAY_DRWN)
		and not (p.powers[pw_shield])
		and not (p.powers[pw_super])
		p.charging = true
		p.mo.state = S_PLAY_SPINDASH
		S_StartSound(p.mo, sfx_spndsh)
	end	
end)


addHook("PlayerThink", function(p)
	if p.pflags & PF_JUMPED
	and (p.mo.state == S_PLAY_SPINDASH)
	and (p.mo.skin == "seles")
	and not (p.cmd.buttons & BT_SPIN)
	and not (p.powers[pw_super])
	and not (p.mo.eflags & MFE_UNDERWATER)
	and not (CBW_Battle)
		p.charging = false
		p.release = true
		p.mo.state = S_PLAY_ROLL
		P_SetObjectMomZ(p.mo, 14*FRACUNIT)
		P_Thrust(p.mo, p.mo.angle, 3*FRACUNIT)
		S_StartSound(p.mo, sfx_zoom)
	end
	if p.pflags & PF_JUMPED
	and (p.mo.state == S_PLAY_SPINDASH)
	and (p.mo.skin == "seles")
	and (p.powers[pw_super])
	and not (p.mo.eflags & MFE_UNDERWATER)
	and not (p.cmd.buttons & BT_SPIN)
	and not (CBW_Battle)
		p.charging = false
		p.release = true
		p.mo.state = S_PLAY_ROLL
		P_SetObjectMomZ(p.mo, 16*FRACUNIT)
		P_Thrust(p.mo, p.mo.angle, 5*FRACUNIT)
		S_StartSound(p.mo, sfx_zoom)
	end
	if p.pflags & PF_JUMPED
	and (p.mo.state == S_PLAY_SPINDASH)
	and (p.mo.skin == "seles")
	and (CBW_Battle)
	and not (p.cmd.buttons & BT_SPIN)	
	and not (p.powers[pw_super])
	and not (p.mo.eflags & MFE_UNDERWATER)	
		p.charging = false
		p.release = true
		p.mo.state = S_PLAY_ROLL
		P_SetObjectMomZ(p.mo, 10*FRACUNIT)
		P_Thrust(p.mo, p.mo.angle, 6*FRACUNIT)
		S_StartSound(p.mo, sfx_zoom)
	end
	if p.pflags & PF_JUMPED
	and (p.mo.state == S_PLAY_SPINDASH)
	and (p.mo.skin == "seles")
	and (p.powers[pw_super])
	and not (p.mo.eflags & MFE_UNDERWATER)
	and (CBW_Battle)
	and not (p.cmd.buttons & BT_SPIN)
		p.charging = false
		p.release = true		
		p.mo.state = S_PLAY_ROLL
		P_SetObjectMomZ(p.mo, 12*FRACUNIT)
		P_Thrust(p.mo, p.mo.angle, 8*FRACUNIT)
		S_StartSound(p.mo, sfx_zoom)
	end
	if p.pflags & PF_JUMPED
	and (p.mo.state == S_PLAY_SPINDASH)
	and (p.mo.skin == "seles")
	and not (p.cmd.buttons & BT_SPIN)
	and not (p.powers[pw_super])
	and (p.mo.eflags & MFE_UNDERWATER)
	and not (CBW_Battle)
		p.charging = false
		p.release = true
		p.mo.state = S_PLAY_ROLL
		P_SetObjectMomZ(p.mo, 10*FRACUNIT)
		P_Thrust(p.mo, p.mo.angle, 2*FRACUNIT)
		S_StartSound(p.mo, sfx_zoom)
	end
	if p.pflags & PF_JUMPED
	and (p.mo.state == S_PLAY_SPINDASH)
	and (p.mo.skin == "seles")
	and (p.powers[pw_super])
	and (p.mo.eflags & MFE_UNDERWATER)
	and not (p.cmd.buttons & BT_SPIN)
	and not (CBW_Battle)
		p.charging = false
		p.release = true
		p.mo.state = S_PLAY_ROLL
		P_SetObjectMomZ(p.mo, 12*FRACUNIT)
		P_Thrust(p.mo, p.mo.angle, 4*FRACUNIT)
		S_StartSound(p.mo, sfx_zoom)
	end
	if p.pflags & PF_JUMPED
	and (p.mo.state == S_PLAY_SPINDASH)
	and (p.mo.skin == "seles")
	and (CBW_Battle)
	and not (p.cmd.buttons & BT_SPIN)	
	and not (p.powers[pw_super])
	and (p.mo.eflags & MFE_UNDERWATER)	
		p.charging = false
		p.release = true
		p.mo.state = S_PLAY_ROLL
		P_SetObjectMomZ(p.mo, 5*FRACUNIT)
		P_Thrust(p.mo, p.mo.angle, 3*FRACUNIT)
		S_StartSound(p.mo, sfx_zoom)
	end
	if p.pflags & PF_JUMPED
	and (p.mo.state == S_PLAY_SPINDASH)
	and (p.mo.skin == "seles")
	and (p.powers[pw_super])
	and not (p.mo.eflags & MFE_UNDERWATER)
	and (CBW_Battle)
	and (p.cmd.buttons & BT_SPIN)
		p.charging = false
		p.release = true
		p.mo.state = S_PLAY_ROLL
		P_SetObjectMomZ(p.mo, 8*FRACUNIT)
		P_Thrust(p.mo, p.mo.angle, 5*FRACUNIT)
		S_StartSound(p.mo, sfx_zoom)
	end	
    if p.charging
	and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
		p.charging = false
    end
    if (P_IsObjectOnGround(p.mo) or (p.mo.eflags & MFE_JUSTHITFLOOR))
	and (p.charging == true)
		p.charging = false
	end	
end)


addHook("PlayerThink", function(p)
    if p.charging and (p.playerstate == PST_DEAD or P_CheckDeathPitCollide(p.mo, true))
        p.charging = false
    end
end)


addHook("PlayerThink", function(p)
    if (p.mo.skin == "seles")
		if (p.mo.state == S_PLAY_FLY)
		and not (p.powers[pw_carry])
		and (p.cmd.buttons & BT_CUSTOM1)
		   S_StartSound(p.mo, sfx_s3k42)
		   p.mo.state = S_PLAY_ROLL
		end
	end
end)


addHook("PlayerThink", function(p)
    if (p.mo.skin == "seles")
		if (p.mo.state == S_PLAY_FLY_TIRED)
		and not (p.powers[pw_carry])
		and (p.cmd.buttons & BT_CUSTOM1)
		   S_StartSound(p.mo, sfx_s3k42)
		   p.mo.state = S_PLAY_ROLL
		end
	end
end)


addHook("PlayerThink", function(p)
    if (p.mo.skin == "seles")
		if (p.mo.state == S_PLAY_SWIM)
		and not (p.powers[pw_carry])
		and (p.cmd.buttons & BT_CUSTOM1)
		   S_StartSound(p.mo, sfx_s3k42)
		   p.mo.state = S_PLAY_ROLL
		end
	end
end)



addHook("PlayerCanDamage", function(p)
    if (p.mo.skin == "seles")
    and (p.mo.state == S_PLAY_ROLL)
        return true   
    end
end)


addHook("PlayerThink", do
    for p in players.iterate
	    if (p.mo.skin == "seles")
	    and (p.cmd.buttons & BT_CUSTOM3)
		and (p.playerstate == PST_LIVE)
		and not (p.powers[pw_carry])
		and not (CBW_Battle)
		and not (gametype == GT_MATCH or gametype == GT_TAG or gametype ==  GT_CTF or gametype == GT_TEAMMATCH)
		and not (p.powers[pw_justsprung])
		and (p.mo.state == S_PLAY_STND or p.mo.state == S_PLAY_WAIT or p.mo.state == S_PLAY_EDGE)
		and P_IsObjectOnGround(p.mo)
		    P_DoPlayerPain(p)
			p.mo.hurt = true
		    S_StartSound(p.mo, sfx_shldls)
		end
		if p.backuptime == nil then p.backuptime = 3 return end
		if p.mo.hurt and (p.playerstate == PST_LIVE)
		and P_IsObjectOnGround(p.mo)
			S_StartSound(p.mo, sfx_s3k4c)
			p.mo.state = S_PLAY_BONK
			p.mo.hurt = false
			p.mo.fumble = true
			p.backupcountdown = true
		end
		if p.backupcountdown
		and (leveltime % 35 == 18)
			p.backuptime = $-1
		end
		if p.backuptime <= 0 and (p.playerstate == PST_LIVE)
		and P_IsObjectOnGround(p.mo)
			p.backupcountdown = false
			p.backuptime = 3
			p.mo.fumble = false
			p.mo.state = S_PLAY_STND
		end
		if p.mo.state == S_PLAY_BONK then
			p.powers[pw_nocontrol] = 1
		end
		if not p.mo.state == S_PLAY_BONK then
			p.powers[pw_nocontrol] = 0
		end
		if p.mo.hurt and (p.playerstate == PST_DEAD or P_CheckDeathPitCollide(p.mo, true))
			p.mo.hurt = false
		end
		if p.mo.hurt
		and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
			p.mo.hurt = false
		end
    end
end)


addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.skin == "seles") return end
    if (p.speed >= skins[p.mo.skin].runspeed)
	and (p.cmd.forwardmove or p.cmd.sidemove)
	and not (p.xmomentum)
	and not (p.boostmentum)
		p.mo.friction = FRACUNIT
		p.charflags = $ & ~SF_NOSKID
	else
		p.mo.friction = 29*FRACUNIT/32
		p.charflags = $ & ~SF_NOSKID
	end	
end)


addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.skin == "seles") return end
    if (FixedHypot(p.rmomx, p.rmomy)  >= 46*FRACUNIT)
    and (FixedDiv(p.mo.momz, p.mo.scale) == 0*FRACUNIT)
		p.charflags = $ | SF_RUNONWATER
    else
		p.charflags = $ & ~SF_RUNONWATER
	end	
end)


addHook("PlayerCanDamage", function(p)
	if not (p.mo and p.mo.skin == "seles") return end
	if (p.speed > 50*FRACUNIT)
	and not (p.xmomentum) then
		return true
	end
end)


//Miscs


addHook("PlayerThink", function(p)	
	if (p.mo.skin == "seles")
	and (p.mo.state == S_PLAY_RUN)
	and (P_IsObjectOnGround(p.mo))
	and not (p.powers[pw_super])
		P_SpawnSkidDust(p, 13*FRACUNIT, sfx_none)
	end
end)


addHook("PlayerThink", function(p)
    if not (p.mo and p.mo.skin == "seles") then return end
	if (p.cmd.buttons & BT_USE)
	and (p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL)
	and not (p.exiting)
	and not (p.xmomentum)
	and not (p.powers[pw_shield] == SH_ELEMENTAL)
	and not (p.powers[pw_shield] == SH_WHIRLWIND)
	    S_StartSound(p.mo, sfx_spin)
	    p.mo.state = S_PLAY_ROLL
		p.pflags = $ & ~PF_THOKKED
		p.pflags = $|PF_JUMPED
	end
end)


addHook("PlayerThink", function(p)
    if (p.mo.skin == "seles")
	and not P_IsObjectOnGround(p.mo)
	    if (p.mo.state == S_PLAY_WALK)
	    or (p.mo.state == S_PLAY_RUN)
	    or (p.mo.state == S_PLAY_DASH)
	    and not (p.xmomentum)
	        p.mo.state = S_PLAY_FALL
	        S_StartSound(p.mo, sfx_s3k51)
		end   
	end
end)


addHook("PlayerThink", function(p)
	if (p.mo.skin == "seles")
	and (p.pflags & PF_JUMPED)
		p.pflags = $ & ~PF_SPINNING
	end
end)


addHook("PlayerThink", function(p)
	if leveltime % 3 == 0 then
		if p.powers[pw_super]
		and p.mo.skin == "seles"
		and not (p.hypercapable)
			local supersparkle = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SUPERSPARK)
	        supersparkle.momx = P_RandomRange(-14, 14) * FRACUNIT + FixedMul(-12, 12, p.mo.scale)
	        supersparkle.momy = P_RandomRange(-14, 14) * FRACUNIT + FixedMul(-12, 12, p.mo.scale)
	        supersparkle.momz = P_RandomRange(-1, 9) * FRACUNIT + FixedMul(-12, 12, p.mo.scale)
	        supersparkle.fuse = 7
	        supersparkle.scale = p.mo.scale
	        supersparkle.source = p.mo
			supersparkle.color = p.mo.color
			supersparkle.colorized = true
	     end
	 end 
end)


addHook("ThinkFrame", do
	for p in players.iterate
	     if (p.mo.state == S_PLAY_WALK) and (p.mo.frame == B) and P_IsObjectOnGround(p.mo)
		 and (p.mo.skin == "seles")
	        S_StartSound(p.mo, sfx_kc50)
		end
	end
end)


addHook("ThinkFrame", do
	for p in players.iterate
	     if (p.mo.state == S_PLAY_WALK) and (p.mo.frame == G) and P_IsObjectOnGround(p.mo)
		 and (p.mo.skin == "seles")
	        S_StartSound(p.mo, sfx_kc50)
		end
	end
end)


addHook("ThinkFrame", do
	for p in players.iterate
	     if (p.mo.state == S_PLAY_RUN) and (p.mo.frame == B) and P_IsObjectOnGround(p.mo)
		 and (p.mo.skin == "seles")
	        S_StartSound(p.mo, sfx_putput)
		end
	end
end)


addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.skin == "seles") then return end
	if (p.mo.state == S_PLAY_ROLL)
	and not (CBW_Battle)
		local gmobj = P_SpawnGhostMobj(p.mo)
		gmobj.fuse = 5
		gmobj.blendmode = AST_TRANSLUCENT
		if gmobj.tracer then gmobj.tracer.fuse = 5 end
		if (leveltime & 1)
			gmobj.frame = $&~FF_TRANSMASK
			gmobj.frame = $|tr_trans70<<FF_TRANSSHIFT
			if (gmobj.tracer)
				gmobj.tracer.frame = $&~FF_TRANSMASK
				gmobj.tracer.frame = $|tr_trans70<<FF_TRANSSHIFT
				gmobj.tracer.blendmode = AST_TRANSLUCENT
			end
		end
	end
end)


addHook("PlayerThink", function(p)
    if not (p.mo and p.mo.skin == "seles") then return end
	if (p.speed > 50*FRACUNIT)
	and not (p.powers[pw_super])
		local gmobj = P_SpawnGhostMobj(p.mo)
		gmobj.fuse = 2
		gmobj.blendmode = AST_ADD
		gmobj.colorized = true
		if gmobj.tracer then gmobj.tracer.fuse = 2 end
		if (leveltime & 1)
			gmobj.frame = $&~FF_TRANSMASK
			gmobj.frame = $|tr_trans70<<FF_TRANSSHIFT
			if (gmobj.tracer)
				gmobj.tracer.frame = $&~FF_TRANSMASK
				gmobj.tracer.frame = $|tr_trans70<<FF_TRANSSHIFT
				gmobj.tracer.blendmode = AST_ADD
				gmobj.tracer.colorized = true
			end
		end
	end
end)


addHook("PlayerThink", function(p)
    if not (p.mo and p.mo.skin == "seles") then return end
	if (p.speed > 70*FRACUNIT)
	and not (p.powers[pw_super])
		local gmobj = P_SpawnGhostMobj(p.mo)
		gmobj.fuse = 3
		gmobj.blendmode = AST_ADD
		gmobj.colorized = true
		if gmobj.tracer then gmobj.tracer.fuse = 3 end
		if (leveltime & 1)
			gmobj.frame = $&~FF_TRANSMASK
			gmobj.frame = $|tr_trans70<<FF_TRANSSHIFT
			if (gmobj.tracer)
				gmobj.tracer.frame = $&~FF_TRANSMASK
				gmobj.tracer.frame = $|tr_trans70<<FF_TRANSSHIFT
				gmobj.tracer.blendmode = AST_ADD
				gmobj.tracer.colorized = true
			end
		end
	end
end)


addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.skin == "seles") then return end
	if (p.powers[pw_super])
	and p.speed + abs(p.mo.momz) > FixedMul(20*FRACUNIT,p.mo.scale)
		local gmobj = P_SpawnGhostMobj(p.mo)
		gmobj.fuse = 3
		gmobj.colorized = true
		if gmobj.tracer then gmobj.tracer.fuse = 4 end
		if (leveltime & 1)
			gmobj.frame = $&~FF_TRANSMASK
			gmobj.frame = $|tr_trans70<<FF_TRANSSHIFT
			if (gmobj.tracer)
				gmobj.tracer.frame = $&~FF_TRANSMASK
				gmobj.tracer.frame = $|tr_trans70<<FF_TRANSSHIFT
			end
		end
	end
end)


addHook("PlayerThink", function(p)
    if not p.exiting then 
	    return 
	end
	
    if p.mo.skin == "seles" 
	and (p.mo.state == S_PLAY_STND or p.mo.state == S_PLAY_EDGE or p.mo.state == S_PLAY_WAIT)
	and p.exiting
	and not p.speed
	and P_IsObjectOnGround(p.mo)
		p.mo.state = S_PLAY_SPRING
		p.drawangle = ANG60
		P_SetObjectMomZ(p.mo, 7*FRACUNIT)
		S_StartSound(p.mo, sfx_jump)
		p.selesvictory = true
		p.startsound = false
	end	
end)


addHook("PlayerThink", function(p)
    if p.mo.skin == "seles" 
		if not p.startsound and p.selesvictory and (p.playerstate == PST_LIVE)
		and p.victoryvoice
		and not (gametype == GT_RACE)
			A_RandomSound(p.mo)
			p.startsound = true
		end
	end	
end)

		
addHook("PlayerThink", function(p)
    if p.mo.skin == "seles" 
    and not p.exiting
		p.selesvictory = false
		p.startsound = false
	end
end)